> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# List lineage for a data model

GET https://api.sigmacomputing.com/v2/dataModels/{dataModelId}/lineage

This endpoint lists the elements, data sources, and upstream lineage for those data sources in a data model, providing a detailed view of how data is interconnected within a data model.

  ### Usage notes
  - Retrieve the **dataModelId** by calling the [/v2/dataModels](https://help.sigmacomputing.com/reference/list-data-models) endpoint.

  ### Usage scenarios
  - **Data governance:** Allows data managers to track how information is used and propagated through different data model elements.
  - **Debugging and optimization:** Helps with identifying and resolving issues in data processing or data model structure.
  - **Data source management**: Identify the dependencies of data sources in use in a specific data model.

  ### Best practices
  - Integrate this information into documentation or data dictionaries to enhance transparency and understanding across teams.
  - Use this endpoint to regularly audit data model structures, ensuring that all data connections and transformations are correct and optimized.

Reference: https://help.sigmacomputing.com/reference/list-data-model-lineage-tree

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/dataModels/{dataModelId}/lineage:
    get:
      operationId: listDataModelLineageTree
      summary: List lineage for a data model
      description: >-
        This endpoint lists the elements, data sources, and upstream lineage for
        those data sources in a data model, providing a detailed view of how
        data is interconnected within a data model.

          ### Usage notes
          - Retrieve the **dataModelId** by calling the [/v2/dataModels](https://help.sigmacomputing.com/reference/list-data-models) endpoint.

          ### Usage scenarios
          - **Data governance:** Allows data managers to track how information is used and propagated through different data model elements.
          - **Debugging and optimization:** Helps with identifying and resolving issues in data processing or data model structure.
          - **Data source management**: Identify the dependencies of data sources in use in a specific data model.

          ### Best practices
          - Integrate this information into documentation or data dictionaries to enhance transparency and understanding across teams.
          - Use this endpoint to regularly audit data model structures, ensuring that all data connections and transformations are correct and optimized.
      tags:
        - dataModels
      parameters:
        - name: dataModelId
          in: path
          required: true
          schema:
            type: string
        - name: page
          in: query
          required: false
          schema:
            type: string
        - name: limit
          in: query
          required: false
          schema:
            type: number
            format: double
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/dataModels_listDataModelLineageTree_Response_200
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf0Type:
      type: string
      enum:
        - table
        - dataset
        - data-model
        - element
        - customSQL
        - csv-upload
      title: >-
        V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf0Type
    V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems0:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf0Type
        sourceIds:
          type:
            - array
            - 'null'
          items:
            type: string
          description: >-
            List of direct sources for the element. Either element IDs or data
            source IDs.
        elementId:
          type: string
          description: Unique identifier of the element
        dataSourceIds:
          type:
            - array
            - 'null'
          items:
            type: string
          description: List of root sources for the element as data source IDs.
      required:
        - type
        - sourceIds
        - elementId
        - dataSourceIds
      title: >-
        V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems0
    V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf1Type:
      type: string
      enum:
        - table
        - dataset
        - data-model
        - element
        - customSQL
        - csv-upload
      title: >-
        V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf1Type
    V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems1:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf1Type
        connectionId:
          type:
            - string
            - 'null'
        name:
          type:
            - string
            - 'null'
        dataModelId:
          type: string
      required:
        - type
        - connectionId
        - name
        - dataModelId
      title: >-
        V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems1
    V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf2Type:
      type: string
      enum:
        - table
        - dataset
        - data-model
        - element
        - customSQL
        - csv-upload
      title: >-
        V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf2Type
    V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems2:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf2Type
        connectionId:
          type:
            - string
            - 'null'
        name:
          type:
            - string
            - 'null'
        inodeId:
          type: string
      required:
        - type
        - connectionId
        - name
        - inodeId
      title: >-
        V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems2
    V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf3Type:
      type: string
      enum:
        - table
        - dataset
        - data-model
        - element
        - customSQL
        - csv-upload
      title: >-
        V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf3Type
    V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems3:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf3Type
        connectionId:
          type:
            - string
            - 'null'
        name:
          type:
            - string
            - 'null'
        definition:
          type: string
      required:
        - type
        - connectionId
        - name
        - definition
      title: >-
        V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems3
    V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf4Type:
      type: string
      enum:
        - table
        - dataset
        - data-model
        - element
        - customSQL
        - csv-upload
      title: >-
        V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf4Type
    V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems4:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf4Type
        connectionId:
          type:
            - string
            - 'null'
        name:
          type:
            - string
            - 'null'
        csvId:
          type: string
          description: Unique identifier of the uploaded CSV file
      required:
        - type
        - connectionId
        - name
        - csvId
      title: >-
        V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems4
    V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems:
      oneOf:
        - $ref: >-
            #/components/schemas/V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems0
        - $ref: >-
            #/components/schemas/V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems1
        - $ref: >-
            #/components/schemas/V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems2
        - $ref: >-
            #/components/schemas/V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems3
        - $ref: >-
            #/components/schemas/V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems4
      title: >-
        V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems
    dataModels_listDataModelLineageTree_Response_200:
      type: object
      properties:
        entries:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2DataModelsDataModelIdLineageGetResponsesContentApplicationJsonSchemaEntriesItems
        nextPage:
          type:
            - string
            - 'null'
        total:
          type: number
          format: double
      required:
        - entries
        - nextPage
      title: dataModels_listDataModelLineageTree_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Request**

```json
{}
```

**Response**

```json
{
  "entries": [
    {
      "dataSourceIds": [
        "datasource-5678efgh"
      ],
      "elementId": "element-1234abcd",
      "sourceIds": [
        "element-9f8b7c6d"
      ],
      "type": "table"
    }
  ],
  "nextPage": "eyJwYWdlIjoiMg==",
  "total": 25
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/dataModels/dataModelId/lineage"

payload = {}
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.get(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/dataModels/dataModelId/lineage';
const options = {
  method: 'GET',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/dataModels/dataModelId/lineage"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/dataModels/dataModelId/lineage")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.sigmacomputing.com/v2/dataModels/dataModelId/lineage")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.sigmacomputing.com/v2/dataModels/dataModelId/lineage', [
  'body' => '{}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/dataModels/dataModelId/lineage");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/dataModels/dataModelId/lineage")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```